open Marker

module Make : functor (T : sig type ('a,'b) t end) -> 
sig
  type 'a t

  val create : unit -> 'a t
    
  val add : 'a t -> 'b marker -> ('a, 'b) T.t ref -> unit

  val find : 'a t -> 'b marker -> ('a, 'b) T.t ref

  val remove : 'a t -> 'b marker -> unit

end = functor (T : sig type ('a,'b) t end) -> 
struct
  type 'a t = unit list ref

  let create = fun () -> ref []

  let add =
    fun data key value -> 
      data := Obj.magic (key, value) :: !data

  let find =
    fun data key -> 
      snd (List.find 
             (fun e -> match (compare (fst e) key) with 
                         Some _ -> true 
                       | _      -> false) 
             (Obj.magic !data))

  let remove =
    fun data key -> 
      data := Obj.magic (List.filter 
                           (fun e -> match (compare (fst e) key) with 
                                       Some _ -> false 
                                     | _      -> true)
                           (Obj.magic !data))
end
