open Marker
open Generic

let int_marker : int marker = make ()
let int = 
  { marker = int_marker;
    gmapT = (fun _ -> fun cont v -> cont v);
    gmapQ = (fun _ -> fun cont v -> cont []) }

let float_marker : float marker = make ()
let float = 
  { marker = float_marker;
    gmapT = (fun _ -> fun cont v -> cont v);
    gmapQ = (fun _ -> fun cont v -> cont []) }

let string_marker : string marker = make ()
let string =
  { marker = string_marker;
    gmapT = (fun _ -> fun cont v -> cont v);
    gmapQ = (fun _ -> fun cont v -> cont []) }

module List_marker = Make (struct type 'a tc = 'a list end)
let list =
  fun element ->
    { marker =  List_marker.make element.marker;
      gmapT = (fun tr ->
        let transform_element = tr.transform element in
        let rec transform_list cont l =
          match l with
          | h::t -> transform_element (fun h -> transform_list (fun t -> cont (h::t)) t) h
          | [] -> cont []
        in
        transform_list);
      gmapQ = fun q ->
        let query_element = q.query element in
        let rec query_list cont l =
          match l with
            | h::t -> query_element (fun h -> query_list (fun t -> cont (h::t)) t) h
            | [] -> cont []
        in
        query_list }
